﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace Editor
{
    public static class FileUtil
    {

        public static int CompareFiles(string a, string b)
        {
            // if this is a dir and b is not, then this wins

            int i = SplitPath(a).Length.CompareTo(SplitPath(b).Length);

            if (i != 0)
                return -i;

            return a.CompareTo(b);
        }

        public static string[] SplitPath(string path)
        {
            List<string> parts = new List<string>();
            parts.Add(Path.GetFileName(path));
            string p = Path.GetDirectoryName(path);
            while (!string.IsNullOrEmpty(p))
            {
                parts.Insert(0, Path.GetFileName(p));
                p = Path.GetDirectoryName(p);
            }
            return parts.ToArray();
        }

        public static string GetRelative(string directory, string file)
        {
            string d = Path.GetFullPath(directory);
            string f = Path.GetFullPath(file);
            if (f.StartsWith(d, StringComparison.CurrentCultureIgnoreCase))
            {
                f = f.Substring(d.Length);
                while (f.StartsWith("/") || f.StartsWith(Path.DirectorySeparatorChar.ToString()))
                    f = f.Substring(1);
            }
            return f;
        }

    }
}
