using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace Editor.Editor
{
    public partial class LoadTicker : Form
    {
        private bool stillLoading;

        public bool StillLoading
        {
            get { return stillLoading; }
            set { stillLoading = value; }
        }

        public string Asset
        {
            get { return label1.Text; }
            set { label1.Text = value; }
        }

        bool open = false;

        public LoadTicker()
        {
            InitializeComponent();
            this.Shown += new EventHandler(LoadTicker_Shown);
            this.FormClosed += new FormClosedEventHandler(LoadTicker_FormClosed);
        }

        void LoadTicker_FormClosed(object sender, FormClosedEventArgs e)
        {
            open = false;
        }

        void LoadTicker_Shown(object sender, EventArgs e)
        {
            open = true;
        }

        public void StartLoading(string asset)
        {
            this.Asset = asset;
            stillLoading = true;
            ThreadPool.QueueUserWorkItem(new WaitCallback(TimeOut), this);
        }

        public void TimeOut(object o)
        {
            LoadTicker lt = o as LoadTicker;
            Thread.Sleep(1000);
            if (!stillLoading)
                return;
            Application.EnableVisualStyles();
            Application.Run(lt);
        }

        public void EndLoad()
        {
            stillLoading = false;
            if (open)
            {
                this.Invoke(new MethodInvoker(this.Close));
            }
        }

    }
}