using System;
using System.Collections.Generic;
using System.Text;
using BinarySerialization;
using System.IO;

namespace Editor.Editor
{
    [Serializable]
    public class Settings
    {
        private string projectFile;

        public string ProjectFile
        {
            get { return projectFile; }
            set { projectFile = value; }
        }

        public void Save(string file)
        {
            BinarySerializer.Serialize(this, file);
        }

        public static Settings Load(string file)
        {
            if (File.Exists(file))
            {
                try
                {
                    return (Settings)BinarySerializer.Deserialize(file);
                }
                catch
                {
                    return null;
                }
            }
            else
                return null;

        }

    }
}
