using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework.Content.Pipeline;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters;
using System.IO;

namespace GameContentPipeline
{
    public abstract class SerializationImporter<T> : ContentImporter<T>
    {
        static Binder binder = null;

        public override T Import(string filename, ContentImporterContext context)
        {
            if (binder == null)
                binder = new Binder();
            BinaryFormatter bf = new BinaryFormatter();
            bf.AssemblyFormat = FormatterAssemblyStyle.Simple;
            bf.Binder = binder;

            T lvl;
            using (FileStream fs = File.OpenRead(filename))
                lvl = (T)bf.Deserialize(fs);

            return lvl;
        }

        public virtual T HandleImport(T import) { return import; }
    }
}
