using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;

namespace GameEngine.Level
{
    public abstract class GameObject
    {
        public string Name;
        public Vector3 Position, Scale = Vector3.One;
        public Quaternion Rotation = Quaternion.Identity;
        public virtual void Draw(GameTime time, DrawInfo renderer) { }
        public virtual void LoadContent(IGraphicsDeviceService graphics, ContentManager content) { }
        public virtual void Update(GameTime time) { }
    }
}
