using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using GameEngine.Data;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics;

namespace GameEngine.Level
{
    public class Scene : GameObject
    {
        private List<GameObject> objects = new List<GameObject>();

        public List<GameObject> Objects
        {
            get { return objects; }
            set { objects = value; }
        }

        private List<Body> polygons = new List<Body>();

        public List<Body> Polygons
        {
            get { return polygons; }
            set { polygons = value; }
        }

        PhysicsSimulator simulator = new PhysicsSimulator(new Microsoft.Xna.Framework.Vector2(0, -1));
        public PhysicsSimulator Simulator
        {
            get { return simulator; }
            set { simulator = value; }
        }


        public Scene()
        {
            
        }

        public override void Update(Microsoft.Xna.Framework.GameTime time)
        {
            simulator.Update((float)time.ElapsedGameTime.TotalSeconds);
            for (int i = 0; i < objects.Count; i++)
            {
                objects[i].Update(time);
                //objects[i].Position = new Microsoft.Xna.Framework.Vector3(polygons[i].Position, 0);
            }
        }

        public override void Draw(Microsoft.Xna.Framework.GameTime time, DrawInfo renderer)
        {
            for (int i = 0; i < objects.Count; i++)
            {
                objects[i].Draw(time, renderer);
            }
        }

    }
}
