﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GameEngine.Xml;
using GameEngine.LevelGeneration;
using System.Xml;

namespace GameEngine
{
    public static class TilesetManager
    {
        static TilesetManager()
        {
            TileSets = new List<TilesetNode>();
        }
        static TilesetNode currentTileset;

        public static Dictionary<string, Dictionary<TileType, List<XmlDocument>>> Tiles { get; set; }
        public static Dictionary<string, Dictionary<SpecialTileNodeType, List<XmlDocument>>> SpecialTiles { get; set; }

        public static List<SceneNode> LoadRandomTile(TileType type)
        {
            return XmlTest.LoadTest(Tiles[currentTileset.Name][type][Util.Random.Next(Tiles[currentTileset.Name][type].Count)]);
        }

        public static List<SceneNode> LoadRandomSpecialTile(SpecialTileNodeType type)
        {
            return XmlTest.LoadTest(SpecialTiles[currentTileset.Name][type][Util.Random.Next(SpecialTiles[currentTileset.Name][type].Count)]);
        }

        public static List<TilesetNode> TileSets { get; private set; }
        public static TilesetNode CurrentTileset
        {
            get
            {
                return currentTileset;
            }
            set
            {
                if (currentTileset == value)
                    return;
                
                currentTileset = value;
                
                if (TilesetChanged != null)
                    TilesetChanged(null, null);
            }
        }
        public static event EventHandler TilesetChanged;
    }
}
