﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using GameEngine.LevelGeneration;
using System.ComponentModel;

namespace GameEngine.Xml
{
    public class TilesetNode : SceneNode
    {
        public const int DefaultHeight = 150;
        public const int DefaultTileSize = 500;
        public const int DefaultExitSize = 250;
        public int TileSize { get; set; }
        public int Height { get; set; }
        public int ExitSize { get; set; }

        public TilesetNode(string name) : base(name)
        {
            this.TileSize = DefaultTileSize;
            this.ExitSize = DefaultExitSize;
            this.Height = DefaultHeight;
        }
        public override void PopulateXml(System.Xml.XmlElement element, System.Xml.XmlDocument document)
        {
            if (Height != DefaultHeight)
                element.SetAttribute("Height", Height.ToString());

            if (TileSize != DefaultTileSize)
                element.SetAttribute("TileSize", TileSize.ToString());

            if (ExitSize != DefaultExitSize)
                element.SetAttribute("ExitSize", ExitSize.ToString());

            base.PopulateXml(element, document);
        }

        public override void SetFromXml(System.Xml.XmlElement element)
        {
            if (element.HasAttribute("Height"))
                this.Height = Int32.Parse(element.Attributes["Height"].Value);

            if (element.HasAttribute("TileSize"))
                this.TileSize = Int32.Parse(element.Attributes["TileSize"].Value);

            if (element.HasAttribute("ExitSize"))
                this.ExitSize = Int32.Parse(element.Attributes["ExitSize"].Value);


            base.SetFromXml(element);
        }

        public override string ToString()
        {
            return name;
        }
    }
}
