using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using Microsoft.Xna.Framework.Content;
using GameEngine.Helpers;
using GameEngine.LevelGeneration;

namespace GameEngine.Xml
{
    public class TilesetReader : ContentTypeReader<TilesetWrapper>
    {
        protected override TilesetWrapper Read(ContentReader input, TilesetWrapper existingInstance)
        {
            if (existingInstance != null)
                return existingInstance;

            TilesetWrapper ts = new TilesetWrapper();
            ts.Tilesets = input.ReadObject<XmlDocument>();
            ts.Tiles = input.ReadObject < Dictionary<string, Dictionary<TileType, List<XmlDocument>>>>();
            ts.SpecialTiles = input.ReadObject<Dictionary<string, Dictionary<SpecialTileNodeType, List<XmlDocument>>>>();

            existingInstance = ts;
            return ts;
        }
    }
}
