﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Content;
using GameEngine.ScreenSystem;
using Microsoft.Xna.Framework;
using GameEngine;

namespace GamePrototype.GameLogic
{
    public class BearSoundsEmitter
    {
        private const float SOUND_VOLUME = 0.055f;
        private int SOUNDS_COUNT = 10;
        private string[] sounds;
        private float timeSinceLastSound;
        private float timeUntilNextSound;

        public BearSoundsEmitter()
        {
            sounds = new string[SOUNDS_COUNT];
            timeSinceLastSound = 0;
            timeUntilNextSound = 0;
        }

        public void LoadSounds(ContentManager content)
        {
            for (int i = 0; i < SOUNDS_COUNT; i++)
            {
                sounds[i] = "Audio/Ambient/bear" + (i+1);
                AudioManager.LoadSoundEffect(content, "Audio/Ambient/bear" + (i + 1));
            }
        }

        public void Update(GameTime gameTime)
        {
            timeSinceLastSound += (int)gameTime.ElapsedMillis();

            if (timeSinceLastSound > timeUntilNextSound)
            {
                string sound = sounds[Util.Random.Next(SOUNDS_COUNT)];

                Vector3 pos = new Vector3((float)Util.Random.NextDouble() - 0.5f, (float)Util.Random.NextDouble() - 0.5f, (float)Util.Random.NextDouble() - 0.5f);
                pos.Normalize();

                AudioManager.PlaySoundEffect(sound, SOUND_VOLUME, ((float)Util.Random.NextDouble() - 0.5f) * 0.5f, pos);
                timeSinceLastSound = 0;
                timeUntilNextSound = Util.Random.Next(1, 3) * 1024;
                
            }
        }

    }
}
