﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GameEngine.Physics;
using GameEngine.Helpers;
using Microsoft.Xna.Framework;
using GameEngine;

namespace GamePrototype.GameLogic
{
    public class FragmentEmitter : ParticleSystem
    {
        public static readonly float SPEED = 0.1f;
        public static readonly int DURATION = 580;
                
        private Vector2 newDirection;
        private Vector3 newPosition;

        public FragmentEmitter(int maxParticles) : base(maxParticles)
        {
        }

        protected override void OnParticleUpdate(ParticleSystemParticle p, GameTime time)
        {
            p.Direction += new Vector3(0, -50, 0) * time.ElapsedSeconds();
            
            base.OnParticleUpdate(p, time);
            if (p.Position.Y <= 0)
                Kill(p);
        }

        public void DoFragments(Vector2 impact, Vector2 impactNormal, Vector2 fromDirection, float height, int fragmentCount)
        {
            newDirection = Vector2.Reflect(fromDirection, impactNormal);
            newPosition = new Vector3(impact.X, height, impact.Y); 
            
            for (int i = 0; i < fragmentCount; i++)
            {
                ParticleSystemParticle p = GetFreeParticle();

                if (p != null)
                {

                    p.Position = newPosition;
                    p.MaxLifeTime = DURATION;
                    p.Speed = SPEED;

                    p.Direction = new Vector3((float)Util.Random.NextDouble() * 10f + newDirection.X - 5f,
                                              (float)Util.Random.NextDouble() * 10f - 5f,
                                              (float)Util.Random.NextDouble() * 10f + newDirection.Y - 5f);                    
                }
            }
        }
    }
}
