﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using GameEngine.ScreenSystem;
using Microsoft.Xna.Framework.Input;
using GameEngine.Xml;
using GameEngine.Helpers;
using Microsoft.Xna.Framework.Graphics;

namespace GamePrototype.Levels
{
    public class Level1 : BaseLevel
    {
        //PhysicsSimulationNode physicsNode;
        //PolygonDrawer debugDrawer;

        public Level1(Game game, GraphicsDeviceManager graphics, string asset) : base(game, graphics, asset)
        {
            Camera.FieldOfView = MathHelper.PiOver4 + MathHelper.PiOver4 / 2f;
            Camera.Position = new Vector3(50, 50, 750f);
            Camera.Target = new Vector3(50, 50, 0f);
        }

        public override void LoadContent()
        {
            base.LoadContent();
            //physicsNode = Forest.Map["physics"] as PhysicsSimulationNode;
            //PhysicsSimulator simulator = physicsNode.Simulator;
            //debugDrawer = new PolygonDrawer(Content.Load<Effect>("hud/primitives"), Graphics.GraphicsDevice);
        }

        public override void Draw(GameTime dt)
        {
            base.Draw(dt);
            
            
            //debugDrawer.DrawPolys(Forest, DrawInfo);
            //debugDrawer.DrawGeoms(physicsNode.Simulator, DrawInfo);
        }

        public override void Update(GameTime dt)
        {
            // Handle input
            HandleInput(dt);
            base.Update(dt);
        }

        private void HandleInput(GameTime dt)
        {
            float dtSeconds = (float)dt.ElapsedGameTime.TotalSeconds;
            if (InputState.IsKeyDown(Keys.PageDown))
                Camera.Zoom(-dtSeconds * 1000f);
            if (InputState.IsKeyDown(Keys.PageUp))
                Camera.Zoom(dtSeconds * 1000f);

            Vector3 cameraMovement = Vector3.Zero;
            if (InputState.IsKeyDown(Keys.Left))
                cameraMovement += new Vector3(dtSeconds * -500f,0,0);
            if (InputState.IsKeyDown(Keys.Right))
                cameraMovement += new Vector3(dtSeconds * 500f,0,0);
            if (InputState.IsKeyDown(Keys.Up))
                cameraMovement += new Vector3(0, dtSeconds * 500f, 0);
            if (InputState.IsKeyDown(Keys.Down))
                cameraMovement += new Vector3(0, dtSeconds * -500f, 0);
            Camera.Target += cameraMovement;
            Camera.Position += cameraMovement;

            if (InputState.MouseState.LeftButton == ButtonState.Pressed)
            {
                foreach (var item in Forest.NodesDepthFirst)
                {
                    PhysObjectNode pon = item as PhysObjectNode;
                    if (pon == null)
                        continue;

                    //pon.Body.ApplyForce(new Vector2(-50,50));

                }
            }

        }
    }
}
