using System;
using System.Diagnostics;
using System.IO;

namespace GamePrototype
{
    static class StartUp
    {
        static void Main(string[] args)
        {
            if (Debugger.IsAttached)
            {
                using (Game1 game = new Game1(args.Length > 0, args))
                {
                    game.Run();
                }
            }
            else
            {

                try
                {
                    using (Game1 game = new Game1(args.Length > 0, args))
                    {
                        game.Run();
                    }
                }
                catch (Exception e)
                {
                    using (StreamWriter sw = new StreamWriter("dump.txt"))
                    {
                        sw.Write(e.Message);
                        sw.Write(e.StackTrace);
                    }
                }
            }
        }

    }
}

